<?php
/**
 * @file
 * Theme functions.
 */
/**
 * The top administrative page listing the instances.
 */
function theme_contextual_elements_instances_table_form($vars) {
  $form = $vars['form'];
  $inst = contextual_elements_get_elements();
  $rows = array();

  // Build the table of instances
  foreach ($inst as $i) {
    // Build list of operations
    $ops = array();
    if (user_access('view contextual element details')) {
      $ops[] = l('view', "admin/config/search/contextual-elements/{$i->cid}/view");
    }
    if (user_access('edit contextual elements')) {
      $ops[] = l('edit', "admin/config/search/contextual-elements/{$i->cid}/edit", array('query' => drupal_get_destination()));
    }
    if (user_access('delete contextual elements')) {
      $ops[] = l('delete', "admin/config/search/contextual-elements/{$i->cid}/delete", array('query' => drupal_get_destination()));
    }

    $row = array();
    $row[] = "<strong>{$i->name}</strong><br /><em>{$i->description}</em>";
    $row[] = drupal_render($form['data'][$i->cid]['status']);
    $row[] = drupal_render($form['data'][$i->cid]['debug']);
    $row[] = drupal_render($form['data'][$i->cid]['weight']);
    $row[] = implode('&nbsp;|&nbsp;', $ops);
    $rows[] = array('data' => $row, 'class' => array('draggable status-' . $i->status));
  }

  // Empty message
  if (empty($rows)) {
    $output = t('No contextual elements have been defined. !link.', array('!link' => l('Create one now', 'admin/config/search/contextual-elements/add')));
  }
  // Theme the table of instances.
  else {
    $output = theme('table', array('header' => $form['headers']['#value'], 'rows' => $rows, 'attributes' => array('id' => 'contextual-elements-instances-table')));
    // Render remaining form elements
    $output .= drupal_render_children($form);
  }

  // Add the Drag n Drop functionality to the table.
  drupal_add_tabledrag('contextual-elements-instances-table', 'order', 'sibling', 'weight-drag');

  return $output;
}
